SystemOrganization addCategory: #'SI-Reflection-Tests'!

!SystemNavigation methodsFor: '*si-reflection' stamp: 'mt 6/6/2010 09:52:02.33'!
allConnectionsOn: aSignal

	^ self
		allConnectionsOn: aSignal
		from: Object! !

!SystemNavigation methodsFor: '*si-reflection' stamp: 'mt 6/6/2010 10:02:48.59'!
allConnectionsOn: aSignal from: aClass
	"Return all methods of a class that contain connections on the given signal."

	| connectionSelectors result tmp |
	tmp := self allCallsOn: aSignal from: aClass. "Fetch connections AND signal sends.."
	
	result := OrderedCollection new.
	connectionSelectors := Object selectors select: [:sel | sel startsWith: #connect:].
	connectionSelectors do: [:sel | 
		result addAll: (self allCallsOn: sel from: aClass)].
	
	^ result select: [:e | tmp includes: e]. "Return the intersection"! !

!SystemNavigation methodsFor: '*si-reflection' stamp: 'mt 6/6/2010 10:00:42.534'!
allSignalEmitsFrom: aSenderClass signal: aSignal

	| connectionSelectors result |
	result := self allCallsOn: aSignal from: aSenderClass. "Fetch connections AND signal sends.."
	
	connectionSelectors := Object selectors select: [:sel | sel startsWith: #connect:].
	connectionSelectors do: [:sel | 
		| calls |
		calls := self allCallsOn: sel from: aSenderClass.
		"Hint: Lose signal sends that are in the same message as the connection. "
		result := result reject: [:e | calls includes: e]].
	
	^ result! !

TestCase subclass: #SignalReflectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Reflection-Tests'!

!SignalReflectionTest methodsFor: 'testing' stamp: 'mt 3/18/2011 09:48:55.694'!
test01FindConnections

	self
		assert: #(test03 test15 test17 test19 test28 test29 test30 test31 test32 test33) asOrderedCollection
		equals: ((SystemNavigation default
			allConnectionsOn: #newSignalProduced
			from: SignalTest) collect: [:methodRef | (methodRef methodSymbol first: 6) asSymbol]) sorted.! !

!SignalReflectionTest methodsFor: 'testing' stamp: 'mt 6/17/2010 15:16:46.095'!
test02FindSignalEmits

	self
		assert: #(value: valueInBlock: valueEx:) asOrderedCollection
		equals: ((SystemNavigation default
			allSignalEmitsFrom: SignalProducer
			signal: #valueChanged:) collect: [:methodRef | methodRef methodSymbol]).! !

!SignalReflectionTest methodsFor: 'testing' stamp: 'mt 11/29/2011 12:15:52.754'!
test03IsSignal

	self
		should: (SignalProducer >> #valueChanged:) isSignal;
		deny: (SignalProducer >> #value:) isSignal.! !

!CompiledMethod methodsFor: '*si-reflection' stamp: 'mt 11/29/2011 12:12:00.315'!
isSignal

	self literalsDo: [:literal |
		literal == #emit ifTrue: [^ true]].
	^ false! !
